#include "Vec_test.h"
#include "Vectors3.h"






VecTest::VecTest()
{
}


void* VecTest::creator()
{
	return new VecTest;
}


MStatus VecTest::doIt(const MArgList& args)
{
	
	

	int  N = args.asInt(9);
	int Flag = args.asInt(10);


	float Ax = args.asDouble(0);
	float Ay = args.asDouble(1);
	float Az = args.asDouble(2);

	float Bx = args.asDouble(3);
	float By = args.asDouble(4);
	float Bz = args.asDouble(5);
	float Cx = args.asDouble(6);
	float Cy = args.asDouble(7);
	float Cz = args.asDouble(8);
	__m128 VecA = _mm_set_ps(Ax, Ay, Az, 1.0f);
	__m128 VecB = _mm_set_ps(Bx, By, Bz, 1.0f);
	__m128 VecC = _mm_set_ps(Cx, Cy, Cz, 1.0f);
	vector3 VecA1 = { float(Ax),float(Ay),float(Az) };
	vector3 VecB1 = { float(Bx), float(By), float(Bz) };
	vector3 VecC1 = { float(Cx), float(Cy), float(Cz) };

	
	
	
	
	float3 VecAa = { Ax, Ay, Az };
	float3 VecBb = { Bx, By, Bz };
	float3 VecCc = { Cx, Cy, Cz };
	
	long  t1 = clock();
	switch (Flag)
	{
	case 1:
	{for (int i = 1;i < N;++i)

	{
		float DisX = Bx - Ax;
		float DisY = By - Ay;
		float DisZ = Bz - Az;

		float summ[] = { Ax / i + (Cx / i - Ax / i)*DisX*DisX / (DisX*DisX) , Ay / i + (Cy / i - Ay / i)*DisY*DisY / (DisY*DisY)  , Az / i + (Cz / i - Az / i)*DisZ*DisZ / (DisZ*DisZ) };

	}}
	break;

	case 2:
	{
#pragma omp parallel for
		for (int i = 1;i < N;++i)

		{
			float DisX = Bx - Ax;
			float DisY = By - Ay;
			float DisZ = Bz - Az;

			
			float summ[] = { Ax / i + (Cx / i - Ax / i)*DisX*DisX / (DisX*DisX) , Ay / i + (Cy / i - Ay / i)*DisY*DisY /( DisY*DisY)  , Az/i + (Cz/i - Az/i)*DisZ*DisZ / (DisZ*DisZ)  };
		}}
	break;
					 // A +(C - A)*dist*dist/(dist*dist) 


	case 3:
	{	
#pragma omp parallel for
	for (int i = 1;i < N;++i)

	{
		
		float in = i;
		__m128 Ind = _mm_set_ps(in, in, in, 1.0f);

	
	__m128 VecA1 = _mm_div_ps(VecA, Ind);
	__m128 VecB1 = _mm_div_ps(VecB, Ind);
	__m128 VecC1 = _mm_div_ps(VecC, Ind);
	
	__m128 dist = _mm_sub_ps(VecB1, VecA1);
	__m128 dist_st = _mm_mul_ps(dist, dist);
	__m128 C_min_A = _mm_sub_ps(VecC1, VecA1);
	__m128 C_min_A1 = _mm_mul_ps(C_min_A, dist_st);
	__m128 C_min_A2 = _mm_div_ps(C_min_A1, dist_st);
	__m128 ress = _mm_add_ps(VecA, C_min_A2);
	
	//float result[4];
	//_mm_store_ps(result, ress);
	
	}	   };
	
	break;	

	case 4:
	{

		for (int i = 1;i < N;++i)

		{
			float in = i;
			__m128 Ind = _mm_set_ps(in, in, in, 1.0f);

			__m128 VecA1 = _mm_div_ps(VecA, Ind);
			__m128 VecB1 = _mm_div_ps(VecB, Ind);
			__m128 VecC1 = _mm_div_ps(VecC, Ind);

			__m128 dist = _mm_sub_ps(VecB1, VecA1);
			__m128 dist_st = _mm_mul_ps(dist, dist);
			__m128 C_min_A = _mm_sub_ps(VecC1, VecA1);
			__m128 C_min_A1 = _mm_mul_ps(C_min_A, dist_st);
			__m128 C_min_A2 = _mm_div_ps(C_min_A1, dist_st);
			__m128 ress = _mm_add_ps(VecA, C_min_A2);

			//float result[4];
			//_mm_store_ps(result, ress);
		}  };

	break;

	case 5:
	{
		
	
		float3 dis;
		float3 summ;
#pragma loop()
		for (int i = 1;i < N;++i)

		{
			
			for (int j = 0; j < 3; ++j)
			{
				
				 dis[j] = VecBb[j] - VecAa[j];


				 summ[j] = VecAa[j] / i + (VecCc[j] / i - VecAa[j] / i)*dis[j] * dis[j] / (dis[j] * dis[j]);
			}

		
			}


	};

	case 6:
	{
		

		float3 dis;
		float3 summ;
		
#pragma omp parallel for
		for (int i = 1;i < N;++i)

		{

			for (int j = 0; j < 3; ++j)
			{

				dis[j] = VecBb[j] - VecAa[j];


				summ[j] = VecAa[j] / i + (VecCc[j] / i - VecAa[j] / i)*dis[j] * dis[j] / (dis[j] * dis[j]);
			}


		}


	};

	case 7:
	{




#pragma omp parallel for
		for (int i = 1;i < N;++i)

		{
			vector3 ind = { float(i),float(i),float(i) };
		
			vector3 dis = VecB1 - VecA1;

			vector3	summ = VecA1 / ind + (VecC1 / ind - VecA1 / ind)*dis * dis / (dis * dis);
			}


		


	};

	case 8:
	{




		for (int i = 1;i < N;++i)

		{
			vector3 ind = { float(i),float(i),float(i) };

			vector3 dis = VecB1 - VecA1;

			vector3	summ = VecA1 / ind + (VecC1 / ind - VecA1 / ind)*dis * dis / (dis * dis);
		}





	};
	
	
	default:
		break;
	}  
	
	
	
		

	long t2 = clock();

	long tim = t2 - t1;


	MPxCommand::setResult(tim);
	return MS::kSuccess;
}

